'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = function (component) {
  var com = (0, _assign2.default)(component);
  var asyncData = com.asyncData,
      fetch = com.fetch;

  var methods = mergeMethods(com);
  if (fetch) {
    com.fetch = createFetchFunction(com, fetch, methods);
  }
  if (asyncData) {
    com.asyncData = createAsyncDataFunction(com, asyncData, methods);
  }
  return com;
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function bindContext(methods, context) {
  var target = { '$store': context.store };
  var result = {};
  for (var key in methods) {
    result[key] = methods[key].bind(target);
  }
  return result;
}

function createAsyncDataFunction(component, originalAsyncData, methods) {
  var _this = this;

  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context) {
      var data, idx, mixin, _r, target, r;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              data = {};
              _context.t0 = _regenerator2.default.keys(component.mixins);

            case 2:
              if ((_context.t1 = _context.t0()).done) {
                _context.next = 12;
                break;
              }

              idx = _context.t1.value;
              mixin = component.mixins[idx];

              if (!(typeof mixin.asyncData !== 'undefined')) {
                _context.next = 10;
                break;
              }

              _context.next = 8;
              return mixin.asyncData(context);

            case 8:
              _r = _context.sent;

              (0, _assign2.default)(data, _r);

            case 10:
              _context.next = 2;
              break;

            case 12:
              target = {};

              (0, _assign2.default)(target, bindContext(methods, context));
              _context.next = 16;
              return originalAsyncData.apply(target, [context]);

            case 16:
              r = _context.sent;

              (0, _assign2.default)(data, r);
              return _context.abrupt('return', data);

            case 19:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
}

function createFetchFunction(component, originalFetch, methods) {
  var _this2 = this;

  return function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(context) {
      var idx, mixin, target;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.t0 = _regenerator2.default.keys(component.mixins);

            case 1:
              if ((_context2.t1 = _context2.t0()).done) {
                _context2.next = 9;
                break;
              }

              idx = _context2.t1.value;
              mixin = component.mixins[idx];

              if (!(typeof mixin.fetch !== 'undefined')) {
                _context2.next = 7;
                break;
              }

              _context2.next = 7;
              return mixin.fetch(context);

            case 7:
              _context2.next = 1;
              break;

            case 9:
              target = {};

              (0, _assign2.default)(target, bindContext(methods, context));
              _context2.next = 13;
              return originalFetch.apply(target, [context]);

            case 13:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this2);
    }));

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }();
}

function mergeMethods(component) {
  var methods = {};
  if (component.mixins) {
    component.mixins.forEach(function (mixin) {
      if (mixin.methods) {
        (0, _assign2.default)(methods, mixin.methods);
      }
    });
  }
  if (component.methods) {
    (0, _assign2.default)(methods, component.methods);
  }
  return methods;
}
//# sourceMappingURL=index.js.map